Index: src/uk/me/parabola/imgfmt/app/trergn/Subdivision.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/trergn/Subdivision.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/trergn/Subdivision.java	(working copy)
@@ -127,11 +127,19 @@
 			log.warn("Subdivision width is " + w + " at " + getCenter());
 			w = 0x7fff;
 		}
+		if (w <= 0) { // think can get this from empty/unbounded maps
+			log.error("Subdivision neg width ", w, "min=", area.getMinLong(), "mid=", longitude, "max=", area.getMaxLong(), "shift=", shift, "mask=", mask, "@", getCenter());
+			w = 0x7fff;
+		}
 
 		if (h > 0xffff) {
 			log.warn("Subdivision height is " + h + " at " + getCenter());
 			h = 0xffff;
 		}
+		if (h <= 0) { // think can get this from empty/unbounded maps
+			log.error("Subdivision neg height ", h, "min=", area.getMinLat(), "mid=", latitude, "max=", area.getMaxLat(), "shift=", shift, "mask=", mask, "@", getCenter());
+			h = 0xffff;
+		}
 
 		this.width = w;
 		this.height = h;
@@ -259,18 +267,18 @@
 	 */
 	public void write(ImgFileWriter file) {
 		log.debug("write subdiv", latitude, longitude);
-		file.put3(startRgnPointer);
-		file.put(getType());
-		file.put3(longitude);
-		file.put3(latitude);
+		file.put3u(startRgnPointer);
+		file.put1u(getType());
+		file.put3s(longitude);
+		file.put3s(latitude);
 		
 		assert width <= 0x7fff;
 		assert height <= 0xffff;
-		file.putChar((char) (width | ((last) ? 0x8000 : 0)));
-		file.putChar((char) height);
+		file.put2u(width | ((last) ? 0x8000 : 0));
+		file.put2u(height);
 
 		if (!divisions.isEmpty()) {
-			file.putChar((char) getNextLevel());
+			file.put2u(getNextLevel());
 		}
 	}
 
@@ -441,8 +449,8 @@
 	 *
 	 * @return A code showing what kinds of element are in this subdivision.
 	 */
-	private byte getType() {
-		byte b = 0;
+	private int getType() {
+		int b = 0;
 		if (hasPoints)
 			b |= 0x10;
 		if (hasIndPoints)
@@ -511,9 +519,9 @@
 	}
 
 	public void writeExtTypeOffsetsRecord(ImgFileWriter file) {
-		file.putInt(extTypeAreasOffset);
-		file.putInt(extTypeLinesOffset);
-		file.putInt(extTypePointsOffset);
+		file.put4(extTypeAreasOffset);
+		file.put4(extTypeLinesOffset);
+		file.put4(extTypePointsOffset);
 		int kinds = 0;
 		if(extTypeAreasSize != 0)
 			++kinds;
@@ -521,14 +529,14 @@
 			++kinds;
 		if(extTypePointsSize != 0)
 			++kinds;
-		file.put((byte)kinds);
+		file.put1u(kinds);
 	}
 
 	public void writeLastExtTypeOffsetsRecord(ImgFileWriter file) {
-		file.putInt(rgnFile.getExtTypeAreasSize());
-		file.putInt(rgnFile.getExtTypeLinesSize());
-		file.putInt(rgnFile.getExtTypePointsSize());
-		file.put((byte)0);
+		file.put4(rgnFile.getExtTypeAreasSize());
+		file.put4(rgnFile.getExtTypeLinesSize());
+		file.put4(rgnFile.getExtTypePointsSize());
+		file.put1u(0);
 	}
 
 	/**
@@ -539,11 +547,11 @@
 	 */
 	public void readExtTypeOffsetsRecord(ImgFileReader reader,
 			Subdivision sdPrev, int size) {
-		extTypeAreasOffset = reader.getInt();
-		extTypeLinesOffset = reader.getInt();
-		extTypePointsOffset = reader.getInt();
+		extTypeAreasOffset = reader.get4();
+		extTypeLinesOffset = reader.get4();
+		extTypePointsOffset = reader.get4();
 		if (size > 12) {
-			int kinds = reader.get();
+			reader.get();  // kinds
 		}
 		if (size > 13)
 			reader.get(size-13);
@@ -564,9 +572,9 @@
 	 * Set the sizes for the extended type data. See {@link #writeLastExtTypeOffsetsRecord(ImgFileWriter)} 
 	 */
 	public void readLastExtTypeOffsetsRecord(ImgFileReader reader, int size) {
-		extTypeAreasSize = reader.getInt() - extTypeAreasOffset;
-		extTypeLinesSize = reader.getInt() - extTypeLinesOffset;
-		extTypePointsSize = reader.getInt() - extTypePointsOffset;
+		extTypeAreasSize = reader.get4() - extTypeAreasOffset;
+		extTypeLinesSize = reader.get4() - extTypeLinesOffset;
+		extTypePointsSize = reader.get4() - extTypePointsOffset;
 		assert extTypeAreasSize >= 0;
 		assert extTypeLinesSize >= 0;
 		assert extTypePointsSize >= 0;
Index: src/uk/me/parabola/imgfmt/app/trergn/TREFile.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/trergn/TREFile.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/trergn/TREFile.java	(working copy)
@@ -91,7 +91,7 @@
 
 		header.setMapInfoSize(header.getMapInfoSize() + enc.getLength() + 1);
 		getWriter().put(val);
-		getWriter().put((byte) 0);
+		getWriter().put1u(0);
 	}
 
 	public void addCopyright(Label cr) {
@@ -175,7 +175,7 @@
 					header.setSubdivSize(header.getSubdivSize() + TREHeader.SUBDIV_REC_SIZE);
 			}
 		}
-		getWriter().putInt(lastRgnPos);
+		getWriter().put4(lastRgnPos);
 		header.setSubdivSize(header.getSubdivSize() + 4);
 	}
 
@@ -330,7 +330,7 @@
 		ImgFileWriter writer = getWriter();
 		for (Label l : copyrights) {
 			header.incCopyrightSize();
-			writer.put3(l.getOffset());
+			writer.put3u(l.getOffset());
 		}
 	}
 
@@ -354,10 +354,14 @@
 	}
 
 	public void setBounds(Area area) {
+		assert Math.abs(area.getMinLat())  <= 0x7fffff : "minlat=" + area.getMinLat();
+		assert Math.abs(area.getMaxLat())  <= 0x7fffff : "maxlat=" + area.getMaxLat();
+		assert Math.abs(area.getMinLong()) <= 0x7fffff : "minlong=" + area.getMinLong();
+		assert Math.abs(area.getMaxLong()) <= 0x7fffff : "maxlong=" + area.getMaxLong();
 		header.setBounds(area);
 	}
 
-	public void addPoiDisplayFlags(byte b) {
+	public void addPoiDisplayFlags(int b) {
 		header.addPoiDisplayFlags(b);
 	}
 
Index: src/uk/me/parabola/imgfmt/app/trergn/TREFileReader.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/trergn/TREFileReader.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/trergn/TREFileReader.java	(working copy)
@@ -94,7 +94,7 @@
 		reader.position(start);
 
 		int subdivNum = 1;
-		int lastRgnOffset = reader.getu3();
+		int lastRgnOffset = reader.get3u();
 		for (int count = 0; count < levelDivs.length && reader.position() < end; count++) {
 
 			Subdivision[] divs = levelDivs[count];
@@ -103,19 +103,20 @@
 				break;
 
 			for (int i = 0; i < divs.length; i++) {
-				int flags = reader.get();
-				int lon = reader.get3();
-				int lat = reader.get3();
-				int width = reader.getChar() & 0x7fff;
-				int height = reader.getChar() & 0xffff;
+				int flags = reader.get1u();
+				int lon = reader.get3s();
+				int lat = reader.get3s();
+				int width = reader.get2u() & 0x7fff;
+				int height = reader.get2u();
 
 				if (count < levelDivs.length-1)
-					reader.getChar();
+					reader.get2u();
 
-				int endRgnOffset = reader.getu3();
+				int endRgnOffset = reader.get3u();
 
 				SubdivData subdivData = new SubdivData(flags,
-						lat, lon, 2*width, 2*height,
+// why???					lat, lon, 2*width, 2*height,
+						lat, lon, width, height,
 						lastRgnOffset, endRgnOffset);
 
 				Subdivision subdiv = Subdivision.readSubdivision(mapLevels[count], subdivData);
@@ -174,9 +175,9 @@
 		List<Zoom> mapLevels = new ArrayList<Zoom>();
 		int end = levelsPos + levelsSize;
 		while (reader.position() < end) {
-			int level = reader.get();
-			int nbits = reader.get();
-			int ndivs = reader.getChar();
+			int level = reader.get1u();
+			int nbits = reader.get1u();
+			int ndivs = reader.get2u();
 
 			Subdivision[] divs = new Subdivision[ndivs];
 			levelDivs.add(divs);
@@ -227,7 +228,7 @@
 		long pos = sect.getPosition();
 		while (pos < sect.getEndPos()) {
 			reader.position(pos);
-			int offset = reader.get3();
+			int offset = reader.get3s();
 			Label label = lblReader.fetchLabel(offset);
 			if (label != null) {
 				msgs.add(label.getText());
Index: src/uk/me/parabola/imgfmt/app/trergn/TREHeader.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/trergn/TREHeader.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/trergn/TREHeader.java	(working copy)
@@ -72,7 +72,7 @@
 	private int subdivPos;
 	private int subdivSize;
 
-	private byte poiDisplayFlags;
+	private int poiDisplayFlags;
 
 	private int displayPriority = DEFAULT_DISPLAY_PRIORITY;
 
@@ -104,10 +104,10 @@
 	 */
 	protected void readFileHeader(ImgFileReader reader) throws ReadFailedException {
 		assert reader.position() == COMMON_HEADER_LEN;
-		int maxLat = reader.get3();
-		int maxLon = reader.get3();
-		int minLat = reader.get3();
-		int minLon = reader.get3();
+		int maxLat = reader.get3s();
+		int maxLon = reader.get3s();
+		int minLat = reader.get3s();
+		int minLon = reader.get3s();
 		// fix problem with value 0x800000 that is interpreted as a negative value
 		if (maxLon <  minLon && maxLon == -8388608 )
 			maxLon = 8388608; // its 180 degrees, not -180
@@ -116,26 +116,26 @@
 		log.info("read area is", getBounds());
 
 		// more to do...
-		mapLevelPos = reader.getInt();
-		mapLevelsSize = reader.getInt();
-		subdivPos = reader.getInt();
-		subdivSize = reader.getInt();
+		mapLevelPos = reader.get4();
+		mapLevelsSize = reader.get4();
+		subdivPos = reader.get4();
+		subdivSize = reader.get4();
 
 		copyright.readSectionInfo(reader, true);
-		reader.getInt();
+		reader.get4();
 
-		poiDisplayFlags = reader.get();
-		displayPriority = reader.get3();
-		reader.getInt();
-		reader.getChar();
+		poiDisplayFlags = reader.get1u();
+		displayPriority = reader.get3u();
+		reader.get4();
+		reader.get2u();
 		reader.get();
 
 		polyline.readSectionInfo(reader, true);
-		reader.getInt();
+		reader.get4();
 		polygon.readSectionInfo(reader, true);
-		reader.getInt();
+		reader.get4();
 		points.readSectionInfo(reader, true);
-		reader.getInt();
+		reader.get4();
 
 		int mapInfoOff = mapLevelPos;
 		if (subdivPos < mapInfoOff)
@@ -146,10 +146,10 @@
 		mapInfoSize = mapInfoOff - getHeaderLength();
 		if (getHeaderLength() > 116) {
 			reader.position(116);
-			mapId = reader.getInt();
+			mapId = reader.get4();
 		}
 		if (getHeaderLength() > 120) {
-			reader.getInt();
+			reader.get4();
 			extTypeOffsets.readSectionInfo(reader, true);
 		}
 	}
@@ -161,44 +161,44 @@
 	 * @param writer The header is written here.
 	 */
 	protected void writeFileHeader(ImgFileWriter writer) {
-		writer.put3(area.getMaxLat());
-		writer.put3(area.getMaxLong());
-		writer.put3(area.getMinLat());
-		writer.put3(area.getMinLong());
+		writer.put3s(area.getMaxLat());
+		writer.put3s(area.getMaxLong());
+		writer.put3s(area.getMinLat());
+		writer.put3s(area.getMinLong());
 
-		writer.putInt(getMapLevelsPos());
-		writer.putInt(getMapLevelsSize());
+		writer.put4(getMapLevelsPos());
+		writer.put4(getMapLevelsSize());
 
-		writer.putInt(getSubdivPos());
-		writer.putInt(getSubdivSize());
+		writer.put4(getSubdivPos());
+		writer.put4(getSubdivSize());
 
 		copyright.writeSectionInfo(writer);
-		writer.putInt(0);
+		writer.put4(0);
 
-		writer.put(getPoiDisplayFlags());
+		writer.put1u(getPoiDisplayFlags());
 
-		writer.put3(displayPriority);
+		writer.put3u(displayPriority);
 		if (custom)
-			writer.putInt(0x170401);
+			writer.put4(0x170401);
 		else
-			writer.putInt(0x110301);
+			writer.put4(0x110301);
 		
-		writer.putChar((char) 1);
-		writer.put((byte) 0);
+		writer.put2u(1);
+		writer.put1u(0);
 
 		polyline.writeSectionInfo(writer);
-		writer.putInt(0);
+		writer.put4(0);
 		polygon.writeSectionInfo(writer);
-		writer.putInt(0);
+		writer.put4(0);
 		points.writeSectionInfo(writer);
-		writer.putInt(0);
+		writer.put4(0);
 
 		// There are a number of versions of the header with increasing lengths
 		if (getHeaderLength() > 116)
-			writer.putInt(getMapId());
+			writer.put4(getMapId());
 
 		if (getHeaderLength() > 120) {
-			writer.putInt(0);
+			writer.put4(0);
 
 			// The record size must be zero if the section is empty for compatibility
 			// with cpreview.
@@ -213,27 +213,27 @@
 			// bottom byte could possibly be a bitmask to say which
 			// types are present (line, area, point) but this is just
 			// conjecture
-			writer.putInt(0x0607);
+			writer.put4(0x0607);
 
 			extTypeOverviews.writeSectionInfo(writer);
-			writer.putChar((char)numExtTypeLineTypes);
-			writer.putChar((char)numExtTypeAreaTypes);
-			writer.putChar((char)numExtTypePointTypes);
+			writer.put2u(numExtTypeLineTypes);
+			writer.put2u(numExtTypeAreaTypes);
+			writer.put2u(numExtTypePointTypes);
 		}
 
 		if (getHeaderLength() > 154) {
 			MapValues mv = new MapValues(mapId, getHeaderLength());
 			mv.calculate();
-			writer.putInt(mv.value(0));
-			writer.putInt(mv.value(1));
-			writer.putInt(mv.value(2));
-			writer.putInt(mv.value(3));
+			writer.put4(mv.value(0));
+			writer.put4(mv.value(1));
+			writer.put4(mv.value(2));
+			writer.put4(mv.value(3));
 
-			writer.putInt(0);
-			writer.putInt(0);
-			writer.putInt(0);
-			writer.putChar((char) 0);
-			writer.putInt(0);
+			writer.put4(0);
+			writer.put4(0);
+			writer.put4(0);
+			writer.put2u(0);
+			writer.put4(0);
 		}
 		
 		writer.position(getHeaderLength());
@@ -271,7 +271,7 @@
 			this.poiDisplayFlags |= POI_FLAG_DRIVE_ON_LEFT; 
 	}
 
-	public void addPoiDisplayFlags(byte poiDisplayFlags) {
+	public void addPoiDisplayFlags(int poiDisplayFlags) {
 		this.poiDisplayFlags |= poiDisplayFlags;
 	}	
 
@@ -324,7 +324,7 @@
 		copyright.inc();
 	}
 
-	protected byte getPoiDisplayFlags() {
+	protected int getPoiDisplayFlags() {
 		return poiDisplayFlags;
 	}
 
Index: src/uk/me/parabola/imgfmt/app/trergn/Zoom.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/trergn/Zoom.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/trergn/Zoom.java	(working copy)
@@ -76,9 +76,9 @@
 	}
 
 	public void write(ImgFileWriter file) {
-		file.put((byte) ((level & 0xf) | (inherited ? 0x80 : 0)));
-		file.put((byte) resolution);
-		file.putChar((char) subdivs.size());
+		file.put1u((level & 0xf) | (inherited ? 0x80 : 0));
+		file.put1u(resolution);
+		file.put2u(subdivs.size());
 	}
 
 	public String toString() {
Index: src/uk/me/parabola/imgfmt/app/typ/DrawOrder.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/typ/DrawOrder.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/typ/DrawOrder.java	(working copy)
@@ -21,8 +21,8 @@
 	}
 
 	public void write(ImgFileWriter writer) {
-		writer.put(type);
-		writer.putInt(subTypes);
+		writer.put1u(type);
+		writer.put4(subTypes);
 	}
 
 	public void addSubtype(int subtype) {
Index: src/uk/me/parabola/imgfmt/app/typ/Rgb.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/typ/Rgb.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/typ/Rgb.java	(working copy)
@@ -53,9 +53,9 @@
 	public void write(ImgFileWriter writer, byte type) {
 		if (type != 0x10)
 			throw new FormatException("Invalid color deep");
-		writer.put((byte) b);
-		writer.put((byte) g);
-		writer.put((byte) r);
+		writer.put1u(b);
+		writer.put1u(g);
+		writer.put1u(r);
 	}
 
 	public boolean isTransparent() {
Index: src/uk/me/parabola/imgfmt/app/typ/TYPFile.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/typ/TYPFile.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/typ/TYPFile.java	(working copy)
@@ -104,7 +104,7 @@
 		Collections.sort(keys);
 
 		// Offset 0 is reserved to mean no label.
-		writer.put((byte) 0);
+		writer.put1u((byte) 0);
 
 		for (SortKey<TypIconSet> key : keys) {
 			int off = writer.position();
@@ -127,7 +127,7 @@
 					String name = encoder.charset().name();
 					throw new TypLabelException(name);
 				}
-				writer.put((byte) 0);
+				writer.put1u((byte) 0);
 			}
 		}
 		Utils.closeFile(writer);
@@ -139,8 +139,8 @@
 		header.getStringIndex().setItemSize((char) (3 + psize));
 
 		for (Map.Entry<Integer, Integer> ent : strToType.entrySet()) {
-			writer.putN(psize, ent.getKey());
-			writer.put3(ent.getValue());
+			writer.putNu(psize, ent.getKey());
+			writer.put3u(ent.getValue());
 		}
 		Utils.closeFile(writer);
 	}
@@ -151,8 +151,8 @@
 		header.getTypeIndex().setItemSize((char) (3 + psize));
 
 		for (Map.Entry<Integer, Integer> ent : typeToStr.entrySet()) {
-			writer.put3(ent.getKey());
-			writer.putN(psize, ent.getValue());
+			writer.put3u(ent.getKey());
+			writer.putNu(psize, ent.getValue());
 		}
 		Utils.closeFile(writer);
 	}
@@ -178,8 +178,8 @@
 		for (TypElement elem : elementData) {
 			int offset = elem.getOffset();
 			int type = elem.getTypeForFile();
-			subWriter.putN(typeSize, type);
-			subWriter.putN(psize, offset);
+			subWriter.putNu(typeSize, type);
+			subWriter.putNu(psize, offset);
 		}
 		Utils.closeFile(subWriter);
 
Index: src/uk/me/parabola/imgfmt/app/typ/TYPHeader.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/typ/TYPHeader.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/typ/TYPHeader.java	(working copy)
@@ -37,14 +37,14 @@
 	private final Section lineData = new Section(pointData);
 	private final Section polygonData = new Section(lineData);
 
-	private final Section pointIndex = new Section(polygonData, (char) 2);
-	private final Section lineIndex = new Section(pointIndex, (char) 2);
-	private final Section polygonIndex = new Section(lineIndex, (char) 2);
+	private final Section pointIndex = new Section(polygonData, 2);
+	private final Section lineIndex = new Section(pointIndex, 2);
+	private final Section polygonIndex = new Section(lineIndex, 2);
 
-	private final Section shapeStacking = new Section(polygonIndex, (char) 5);
+	private final Section shapeStacking = new Section(polygonIndex, 5);
 
 	private final Section iconData = new Section(polygonIndex);
-	private final Section iconIndex = new Section(iconData, (char) 3);
+	private final Section iconIndex = new Section(iconData, 3);
 
 	private final Section labels = new Section(iconIndex);
 	private final Section stringIndex = new Section(labels);
@@ -64,34 +64,34 @@
 	protected void readFileHeader(ImgFileReader reader) {
 		// Reset position for the real header reading code.
 		reader.position(COMMON_HEADER_LEN);
-		codePage = reader.getChar();	// 1252
-		pointData.setPosition(reader.getInt());
-		pointData.setSize(reader.getInt());
+		codePage = (char) reader.get2u();	// 1252
+		pointData.setPosition(reader.get4());
+		pointData.setSize(reader.get4());
 
-		lineData.setPosition(reader.getInt());
-		lineData.setSize(reader.getInt());
+		lineData.setPosition(reader.get4());
+		lineData.setSize(reader.get4());
 
-		polygonData.setPosition(reader.getInt());
-		polygonData.setSize(reader.getInt());
+		polygonData.setPosition(reader.get4());
+		polygonData.setSize(reader.get4());
 
-		familyId = reader.getChar();
-		productId = reader.getChar();
+		familyId = (char) reader.get2u();
+		productId = (char) reader.get2u();
 
-		pointIndex.setPosition(reader.getInt());
-		pointIndex.setItemSize(reader.getChar());
-		pointIndex.setSize(reader.getInt());
+		pointIndex.setPosition(reader.get4());
+		pointIndex.setItemSize(reader.get2u());
+		pointIndex.setSize(reader.get4());
 
-		lineIndex.setPosition(reader.getInt());
-		lineIndex.setItemSize(reader.getChar());
-		lineIndex.setSize(reader.getInt());
+		lineIndex.setPosition(reader.get4());
+		lineIndex.setItemSize(reader.get2u());
+		lineIndex.setSize(reader.get4());
 
-		polygonIndex.setPosition(reader.getInt());
-		polygonIndex.setItemSize(reader.getChar());
-		polygonIndex.setSize(reader.getInt());
+		polygonIndex.setPosition(reader.get4());
+		polygonIndex.setItemSize(reader.get2u());
+		polygonIndex.setSize(reader.get4());
 
-		shapeStacking.setPosition(reader.getInt());
-		shapeStacking.setItemSize(reader.getChar());
-		shapeStacking.setSize(reader.getInt());
+		shapeStacking.setPosition(reader.get4());
+		shapeStacking.setItemSize(reader.get2u());
+		shapeStacking.setSize(reader.get4());
 	}
 
 	/**
@@ -103,14 +103,14 @@
 	 * @param writer The header is written here.
 	 */
 	protected void writeFileHeader(ImgFileWriter writer) {
-		writer.putChar(codePage);
+		writer.put2u(codePage);
 
 		pointData.writeSectionInfo(writer);
 		lineData.writeSectionInfo(writer);
 		polygonData.writeSectionInfo(writer);
 
-		writer.putChar(familyId);
-		writer.putChar(productId);
+		writer.put2u(familyId);
+		writer.put2u(productId);
 
 		// Can't use Section.writeSectionInfo here as there is an unusual layout.
 		writeSectionInfo(writer, pointIndex);
@@ -120,9 +120,9 @@
 
 		if (getHeaderLength() > 0x5b) {
 			writeSectionInfo(writer, iconIndex);
-			writer.put((byte) 0x13);
+			writer.put1u(0x13);
 			iconData.writeSectionInfo(writer);
-			writer.putInt(0);
+			writer.put4(0);
 		}
 
 		if (getHeaderLength() > 0x6e) {
@@ -129,17 +129,17 @@
 			labels.writeSectionInfo(writer);
 
 			// not known, guessing. Different layout to other files.
-			writer.putInt(stringIndex.getItemSize());
-			writer.putInt(0x1b);
-			writer.putInt(stringIndex.getPosition());
-			writer.putInt(stringIndex.getSize());
+			writer.put4(stringIndex.getItemSize());
+			writer.put4(0x1b);
+			writer.put4(stringIndex.getPosition());
+			writer.put4(stringIndex.getSize());
 
-			writer.putInt(typeIndex.getItemSize());
-			writer.putInt(0x1b);
-			writer.putInt(typeIndex.getPosition());
-			writer.putInt(typeIndex.getSize());
+			writer.put4(typeIndex.getItemSize());
+			writer.put4(0x1b);
+			writer.put4(typeIndex.getPosition());
+			writer.put4(typeIndex.getSize());
 
-			writer.putChar((char) 0);
+			writer.put2u(0);
 		}
 	}
 
@@ -148,9 +148,9 @@
 	 * that have an item size.
 	 */
 	private void writeSectionInfo(ImgFileWriter writer, Section section) {
-		writer.putInt(section.getPosition());
-		writer.putChar(section.getItemSize());
-		writer.putInt(section.getSize());
+		writer.put4(section.getPosition());
+		writer.put2u(section.getItemSize());
+		writer.put4(section.getSize());
 	}
 
 	void setCodePage(char codePage) {
Index: src/uk/me/parabola/imgfmt/app/typ/TrueImage.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/typ/TrueImage.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/typ/TrueImage.java	(working copy)
@@ -51,9 +51,9 @@
 
 		// For mode 16, the transparent pixel precedes the pixmap data.
 		if (mode == 16) {
-			writer.put((byte) (transparentPixel>>8));
-			writer.put((byte) (transparentPixel>>16));
-			writer.put((byte) (transparentPixel>>24));
+			writer.put1u(transparentPixel>>8);
+			writer.put1u(transparentPixel>>16);
+			writer.put1u(transparentPixel>>24);
 		}
 
 		boolean hasAlpha = mode == 32;
Index: src/uk/me/parabola/imgfmt/app/typ/TypElement.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/typ/TypElement.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/typ/TypElement.java	(working copy)
@@ -159,9 +159,9 @@
 
 		// write out the length, I'm assuming that it will be 1 or 2 bytes
 		if (len > 0xff)
-			writer.putChar((char) len);
+			writer.put2u(len);
 		else
-			writer.put((byte) len);
+			writer.put1u(len);
 
 		// Prepare and write buffer
 		out.flip();
@@ -181,7 +181,7 @@
 		if (nightFontColour != null)
 			fontExt |= 0x10;
 
-		writer.put(fontExt);
+		writer.put1u(fontExt);
 
 		if (dayFontColour != null)
 			dayFontColour.write(writer, (byte) 0x10);
@@ -199,8 +199,8 @@
 	protected void writeImage(ImgFileWriter writer, Xpm xpm) {
 		ColourInfo colourInfo = xpm.getColourInfo();
 
-		writer.put((byte) colourInfo.getNumberOfSColoursForCM());
-		writer.put((byte) colourInfo.getColourMode());
+		writer.put1u(colourInfo.getNumberOfSColoursForCM());
+		writer.put1u(colourInfo.getColourMode());
 
 		colourInfo.write(writer);
 		xpm.writeImage(writer);
Index: src/uk/me/parabola/imgfmt/app/typ/TypIconSet.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/typ/TypIconSet.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/typ/TypIconSet.java	(working copy)
@@ -31,15 +31,15 @@
 		offset = writer.position();
 
 		// Start with the number of icons
-		writer.put((byte) icons.size());
+		writer.put1u(icons.size());
 
 		for (Xpm xpm : icons) {
 			ColourInfo colourInfo = xpm.getColourInfo();
 			int nbits = calcBits(colourInfo);
-			writer.putChar((char) (nbits/2));
-			writer.put((byte) 1);
-			writer.put((byte) colourInfo.getWidth());
-			writer.put((byte) colourInfo.getHeight());
+			writer.put2u(nbits/2);
+			writer.put1u(1);
+			writer.put1u(colourInfo.getWidth());
+			writer.put1u(colourInfo.getHeight());
 			writeImage(writer, xpm);
 		}
 	}
Index: src/uk/me/parabola/imgfmt/app/typ/TypLine.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/typ/TypLine.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/typ/TypLine.java	(working copy)
@@ -60,8 +60,8 @@
 		ColourInfo colourInfo = xpm.getColourInfo();
 		int scheme = colourInfo.getColourScheme() & 0x7;
 
-		writer.put((byte) ((scheme & 0x7) | (height << 3)));
-		writer.put(flags);
+		writer.put1u((scheme & 0x7) | (height << 3));
+		writer.put1u(flags);
 
 		colourInfo.write(writer);
 		if (xpm.hasImage())
@@ -68,9 +68,9 @@
 			xpm.writeImage(writer);
 
 		if (height == 0) {
-			writer.put(lineWidth);
+			writer.put1u(lineWidth);
 			if ((scheme&~1) != 6)
-				writer.put((byte) (lineWidth + 2*borderWidth));
+				writer.put1u(lineWidth + 2*borderWidth);
 		}
 
 		// The labels have a length byte to show the number of bytes following. There is
Index: src/uk/me/parabola/imgfmt/app/typ/TypPoint.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/typ/TypPoint.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/typ/TypPoint.java	(working copy)
@@ -42,12 +42,12 @@
 		if (fontStyle != 0 || dayFontColour != null || nightFontColour != null)
 			flags |= F_EXTENDED_FONT;
 
-		writer.put(flags);
+		writer.put1u(flags);
 
 		// Width and height is the same for day and night images, so it is written once only.
 		ColourInfo colourInfo = xpm.getColourInfo();
-		writer.put((byte) colourInfo.getWidth());
-		writer.put((byte) colourInfo.getHeight());
+		writer.put1u(colourInfo.getWidth());
+		writer.put1u(colourInfo.getHeight());
 
 		// Day or only image
 		writeImage(writer, xpm);
Index: src/uk/me/parabola/imgfmt/app/typ/TypPolygon.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/typ/TypPolygon.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/typ/TypPolygon.java	(working copy)
@@ -36,7 +36,7 @@
 		if (fontStyle != 0 || dayFontColour != null)
 			scheme |= F_EXTENDED;
 
-		writer.put((byte) scheme);
+		writer.put1u(scheme);
 
 		colourInfo.write(writer);
 		if (xpm.hasImage())
Index: src/uk/me/parabola/imgfmt/mdxfmt/MdxFileReader.java
===================================================================
--- src/uk/me/parabola/imgfmt/mdxfmt/MdxFileReader.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/mdxfmt/MdxFileReader.java	(working copy)
@@ -41,19 +41,19 @@
 	private void readMaps() {
 		for (int i = 0; i < numberOfMaps; i++) {
 			MapInfo info = new MapInfo();
-			info.setHexMapname(reader.getInt());
-			info.setProductId(reader.getChar());
-			info.setFamilyId(reader.getChar());
-			info.setMapname(reader.getInt());
+			info.setHexMapname(reader.get4());
+			info.setProductId((char) reader.get2u());
+			info.setFamilyId((char) reader.get2u());
+			info.setMapname(reader.get4());
 			maps.add(info);
 		}
 	}
 
 	private void readHeader() {
-		reader.getInt();
-		reader.getChar();
-		reader.getInt();
-		numberOfMaps = reader.getInt();
+		reader.get4();
+		reader.get2u();
+		reader.get4();
+		numberOfMaps = reader.get4();
 	}
 
 	public List<MapInfo> getMaps() {
Index: src/uk/me/parabola/imgfmt/mps/MpsFileReader.java
===================================================================
--- src/uk/me/parabola/imgfmt/mps/MpsFileReader.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/mps/MpsFileReader.java	(working copy)
@@ -60,7 +60,7 @@
 	private void readBlocks() {
 		byte type;
 		while ((type = reader.get()) > 0) {
-			int len = reader.getChar();
+			int len = reader.get2u();
 
 			switch (type) {
 			case 0x4c:
@@ -79,23 +79,23 @@
 
 	private void readMapBlock() {
 		MapBlock block = new MapBlock(codePage);
-		int val = reader.getInt();
+		int val = reader.get4();
 		block.setIds(val >>> 16, val & 0xffff);
-		block.setMapNumber(reader.getInt());
+		block.setMapNumber(reader.get4());
 
 		byte[] zString = reader.getZString();
 		block.setSeriesName(decodeToString(zString));
 		block.setMapDescription(decodeToString(reader.getZString()));
 		block.setAreaName(decodeToString(reader.getZString()));
-		block.setHexNumber(reader.getInt());
-		reader.getInt();
+		block.setHexNumber(reader.get4());
+		reader.get4();
 		maps.add(block);
 	}
 
 	private void readProductBlock() {
 		ProductBlock block = new ProductBlock(codePage);
-		block.setProductId(reader.getChar());
-		block.setFamilyId(reader.getChar());
+		block.setProductId(reader.get2u());
+		block.setFamilyId(reader.get2u());
 		block.setDescription(decodeToString(reader.getZString()));
 		products.add(block);
 	}
Index: src/uk/me/parabola/mkgmap/build/MapBuilder.java
===================================================================
--- src/uk/me/parabola/mkgmap/build/MapBuilder.java	(revision 4130)
+++ src/uk/me/parabola/mkgmap/build/MapBuilder.java	(working copy)
@@ -1136,7 +1136,7 @@
 					if(pointIndex > 255) {
 						System.err.println("Can't set city point index for " + name + " (too many indexed points in division)\n");
 					} else {
-						c.setPointIndex((byte)pointIndex);
+						c.setPointIndex(pointIndex);
 						c.setSubdivision(div);
 					}
 				}
Index: src/uk/me/parabola/mkgmap/combiners/FileInfo.java
===================================================================
--- src/uk/me/parabola/mkgmap/combiners/FileInfo.java	(revision 4130)
+++ src/uk/me/parabola/mkgmap/combiners/FileInfo.java	(working copy)
@@ -195,7 +195,7 @@
 		try (ImgChannel chan = new FileImgChannel(filename, "r"); BufferedImgFileReader fr = new BufferedImgFileReader(chan))
 		{
 			fr.position(0x15);
-			info.setCodePage(fr.getChar());
+			info.setCodePage(fr.get2u());
 		} catch (IOException e) {
 			e.printStackTrace();
 		}
Index: src/uk/me/parabola/mkgmap/general/MapDetails.java
===================================================================
--- src/uk/me/parabola/mkgmap/general/MapDetails.java	(revision 4130)
+++ src/uk/me/parabola/mkgmap/general/MapDetails.java	(working copy)
@@ -159,6 +159,8 @@
 	 * @return An area covering all the points in the map.
 	 */
 	public Area getBounds() {
+		if (minLatHp == Integer.MAX_VALUE) // nothing called addToBounds
+			return new Area(1, 1, -1, -1); // return invalid bbox that doesn't break signed 3 byte IO in img file
 		int minLat = minLatHp >> Coord.DELTA_SHIFT;
 		int maxLat = maxLatHp >> Coord.DELTA_SHIFT;
 		int minLon = minLonHp >> Coord.DELTA_SHIFT;
